#pragma warning(disable : 4514)
#pragma warning(push,1)
#include <windows.h>
#include <stddef.h>
#pragma warning(pop)

enum CrestLanguage {
  lngEnabled = 0,
  lngCLRCursor,
  lngShootMode,
  lngCRColor,
  lngCURColor,
  lngActivs,
  lngCtrl,
  lngAlt,
  lngShift,
  lngLock,
  lngCaps,
  lngNum,
  lngScroll,
  lngAutoShoot,
  lngOpt,
  lngColorerCor,
  lngDrawV,
  lngDrawH,
  lngShCfg,
  lngNewFar,
  lngIgnDel,
  lngAlways,
  lngNever,
  lngEditorCrestSetup,
  lngShowRuler
};

//#define __USE_FSF__ 1

#ifndef _MSC_VER
#define __forceinline __inline
#endif

#ifndef SLASH_CHAR
  #define SLASH_CHAR  '\\'
//  #define SLASH_STR   "\\"
#endif

#define MK_DWORD( lw,hw )         (((((DWORD)hw)&0x0000FFFFUL) << 16) | (((WORD)lw)&0x0000FFFFUL))
#define MK_ID( v,v1,v2,v3 )       MK_DWORD( MK_WORD(v,v1),MK_WORD(v2,v3) )
#define MAX_WORD                  ((WORD)0xFFFFU)
#define MK_WORD( lb,hb )          ((WORD)(((((WORD)(hb))&0x00FFU) << 8) | (((BYTE)(lb))&0x00FFU)))
//#define IS_FLAG( val,flag )       (((val)&(flag))==(flag))
#define IS_FLAG( val,flag )       ((val)&(flag))
#define SET_FLAG( val,flag )      (val |= (flag))
#define CLR_FLAG( val,flag )      (val &= ~(flag))

#if defined(__USE_FSF__)
  #define F_DECL_STRUCTDATA     static struct PluginStartupInfo    Info; \
                                static struct FarStandardFunctions FSF;
  #define F_INIT_STRUCTDATA(v)  Info = *(v);       \
                                FSF  = *(v)->FSF;

  #define F_CMP_NAME( patt,nm ) FSF.ProcessName( patt,nm,PN_SKIPPATH|PN_CMPNAMELIST )
  #define F_SPRINTF             FSF.sprintf
  #define F_ATOI                FSF.atoi
#else
  #define F_DECL_STRUCTDATA     static struct PluginStartupInfo    Info;
  #define F_INIT_STRUCTDATA(v)  Info = *(v);

  #define F_CMP_NAME( patt,nm ) InPattern( (patt),(nm) )
  #define F_SPRINTF             wsprintf
  #define F_ATOI                atou
#endif

#ifdef __WATCOMC__
#  pragma aux fillmem\
    parm [edi] [eax] [ecx]\
    modify exact [ecx edi]\
    =\
    "rep stosb" ;
#define zero_mem(mem,sz) fillmem(mem,0,sz)
#else
#define zero_mem(p,sz) memset((p),0,(sz))
#endif
#define IsPrint(c) ((c)>=' ' && (c)<127)
/*
__forceinline static BOOL IsPrint(CHAR c)
{
    WORD wFlags;
    OemToCharBuff(&c,&c,1);
    GetStringTypeA(LOCALE_USER_DEFAULT,CT_CTYPE1,&c,1,&wFlags);
    return wFlags&(C1_UPPER|C1_LOWER|C1_DIGIT|C1_PUNCT|C1_ALPHA|C1_BLANK);
}
*/
#define StrChr(s,c)  scrchr(s,(char)(c))
#define StrRChr(s,c) scrrchr(s,(char)(c))

//- Hardvare scan codes
#define scL_SHIFT       0x2A
#define scR_SHIFT       0x36
#define scSHIFT         scL_SHIFT
#define scALT           0x38
#define scCONTROL       0x1D
#define scCAPSLOCK      0xBA
#define scNUMLOCK       0xC5
#define scSCROLLLOCK    0xC6
#define scPRINTSCREEN   0xAA
#define scPAUSE         0xFA

#define scESC       0x01

#define scF1        0x3B
#define scF2        0x3C
#define scF3        0x3D
#define scF4        0x3E
#define scF5        0x3F
#define scF6        0x40
#define scF7        0x41
#define scF8        0x42
#define scF9        0x43
#define scF10       0x44
#define scF11       0x57
#define scF12       0x58

#define scTILDA     0x29
#define sc1         0x02
#define sc2         0x03
#define sc3         0x04
#define sc4         0x05
#define sc5         0x06
#define sc6         0x07
#define sc7         0x08
#define sc8         0x09
#define sc9         0x0A
#define sc0         0x0B
#define scMINUS     0x0C
#define scEQUAL     0x0D
#define scBKSLASH   0x2B
#define scBACKSPACE 0x0E

#define scTAB       0x0F
#define scQ         0x10
#define scW         0x11
#define scE         0x12
#define scR         0x13
#define scT         0x14
#define scY         0x15
#define scU         0x16
#define scI         0x17
#define scO         0x18
#define scP         0x19
#define scLBOX      0x1A
#define scRBOX      0x1B
#define scRETURN    0x1C

#define scA         0x1E
#define scS         0x1F
#define scD         0x20
#define scF         0x21
#define scG         0x22
#define scH         0x23
#define scJ         0x24
#define scK         0x25
#define scL         0x26
#define scSEMICOLON 0x27
#define scCHAR      0x28

#define scZ         0x2C
#define scX         0x2D
#define scC         0x2E
#define scV         0x2F
#define scB         0x30
#define scN         0x31
#define scM         0x32
#define scLESS      0x33
#define scMORE      0x34
#define scQUESTION  0x35

#define scSPACE     0x39

#define scSLASH     0x35
#define scSTAR      0x37
#define scGRMINUS   0x4A
#define scGRPLUS    0x4E
#define scHOME      0x47
#define scUP        0x48
#define scPGUP      0x49
#define scLEFT      0x4B
#define scCENTER    0x4C
#define scRIGHT     0x4D
#define scEND       0x4F
#define scDOWN      0x50
#define scPGDOWN    0x51
#define scINS       0x52
#define scDEL       0x53


#pragma warning(push,1)
#include "plugin.hpp"
#pragma warning(pop)

static void StrCpy( char *dest,const char *src,int dest_sz )
  {
      int i=strlen(src);
      if( i>=dest_sz )i=dest_sz-1;
      memcpy( dest,src,i );
      dest[i] = '\0';
}

//- ALL VERSION OPTIONS
typedef struct _CROptions_v1{       //First version
  DWORD _Magic;
  BOOL  _Enabled;
  int   _Color;
  WORD  _TempShow;
  WORD  _LockShow;
  WORD  _Flags;
  char  _AlwaysShow[ 256 ];
  char  _NotShow[ 256 ];
}CROptions_v1;

typedef struct _CROptions{         //Second version
  CROptions_v1 Ver1;
  int          _CenterColor;
}CROptions;
//- universion OPTIONS FIELDS
#define opMagic           Ver1._Magic          //First version
#define opEnabled         Ver1._Enabled
#define opColor           Ver1._Color
#define opTempShow        Ver1._TempShow
#define opLockShow        Ver1._LockShow
#define opFlags           Ver1._Flags
#define opAlwaysShow      Ver1._AlwaysShow
#define opNotShow         Ver1._NotShow
#define opCenterColor     _CenterColor         //Second version

//- Meaning
#define CR_VERSION     " Crest v1.11"                 //Current version string
#define CR_MAGIC_v1    MK_ID( 'C','r','E','s' )      //First version
#define CR_MAGIC       MK_ID( 'C','r','E','\x01' )   //Second version

#define CRTS_CONTROL   0x0001
#define CRTS_ALT       0x0002
#define CRTS_SHIFT     0x0004

#define CRLS_CAPS      0x0001
#define CRLS_NUM       0x0002
#define CRLS_SCROLL    0x0004

#define CRF_COLORER    0x0001
#define CRF_VERT       0x0002
#define CRF_HORZ       0x0004
#define CRF_CURSOR     0x0008
#define CRF_PLUGINMENU 0x0010
#define CRF_FAR173     0x0020
#define CRF_SHOOT      0x0040
#define CRF_IGNOREDEL  0x0080
#define CRF_AUTOSHOOT  0x0100
#define CRF_SHOWRULER  0x0200

//- Variables
//FAR
F_DECL_STRUCTDATA
static struct EditorInfo EInfo;

//Last used positions
static struct LastPos{
    int   curX;
    int   curY;
    int   hilight;
    int   isHilight;
    int   TopLine;
    WORD  LastFlags;
} last;

static char  Chars[256];

//W9x shifts
static DWORD LastShiftState = 0;
static BOOL  isWinNT;
//REG key name
static char  KeyName[ 256 ];
//POptions

static CROptions Options;
//- Options getters

#define isColorer()     (Options.opFlags&CRF_COLORER)
#define isCursor()      (Options.opFlags&CRF_CURSOR)
#define isPluginMenu()  (Options.opFlags&CRF_PLUGINMENU)
#define isCrest()       (Options.opFlags&(CRF_VERT|CRF_HORZ))
#define isNewFAR()      (Options.opFlags&CRF_FAR173)
#define isShoot()       (Options.opFlags&CRF_SHOOT)
#define isIgnoreDEL()   (Options.opFlags&CRF_IGNOREDEL)
#define isAutoShoot()   (Options.opFlags&CRF_AUTOSHOOT)
#define isShowRuler()   (Options.opFlags&CRF_SHOWRULER)

static char* scrchr(const char* s, char c)
{
    while(*s)
        if( *s == c ) return (char*)s;
        else s++;
    return NULL;
}

static char* scrrchr(const char * s, char c)
{
    const char *start = s;

    while (*s++) continue;
    while (--s != start ) if( *s == c ) return (char*)s;
    return NULL;
}

#if !defined(__USE_FSF__)
static unsigned int atou( const char *string )
{
    register unsigned int res=0,x;
    for(;;string++){
        x=*(unsigned char*)string;
        if( !x )break;
        x-='0';
        if( x>9 )break;
        res<<=1;
        res+=(res<<2)+x;
    }
    return res;
}

static BOOL InPattern(char* patt,char* nm)
{
    char c;
    BOOL res;
    char* p=patt;

    do{
        while( *p && *p!=',' ) p++;
        c=*p;
        *p='\0';
        res=Info.CmpName(patt,nm,TRUE);
        *p=c;
        if( res )return res;
        patt=++p;
    }while(c);
    return FALSE;
}
#endif //!__USE_FSF__

static const char szRegValue    []="Data";
static const char szDecimalFmt  []="%d";

static void LoadREG( void )
  {
     CROptions op;
     HKEY      key = NULL;
     DWORD     tp = REG_BINARY,
               sz = sizeof(op);

     if ( RegCreateKey(HKEY_CURRENT_USER,KeyName,&key )          != ERROR_SUCCESS ) return;
     if ( RegQueryValueEx( key,szRegValue,NULL,&tp,(LPBYTE)&op,&sz ) != ERROR_SUCCESS ) { RegCloseKey(key); return; }
     if ( tp                                                     != REG_BINARY    ) { RegCloseKey(key); return; }

/* Import from version 1 */
     if ( sz == sizeof(CROptions_v1) && op.opMagic == CR_MAGIC_v1 ) {
       memcpy( &Options,&op,sizeof(CROptions_v1) );
       Options.opCenterColor  = 0x81;
       Options.opFlags       |= CRF_VERT | CRF_HORZ;
     } else
/* Second version */
     if ( sz == sizeof(CROptions) && op.opMagic == CR_MAGIC ) {
       memcpy( &Options,&op,sizeof(CROptions) );
     } else
/* Do not change - unknown version */
       ;
}
__forceinline static void SaveREG(void)
  {  HKEY key;
     if ( RegCreateKey(HKEY_CURRENT_USER,KeyName,&key ) == ERROR_SUCCESS ){
         RegSetValueEx( key,szRegValue,0,REG_BINARY,(LPBYTE)&Options,sizeof(Options) );
         RegCloseKey(key);
     }
}

__forceinline static BYTE IsChar( BYTE ch )
  {
//Check if char in DOS codepage is character
     if ( !IsPrint(ch) && StrChr(Chars,ch) == NULL ) return 0;

     if ( EInfo.TableNum != -1 ) {
        struct CharTableSet buff;
        if ( Info.CharTable( EInfo.TableNum,(char*)&buff,sizeof(buff) ) == -1 )
          return ch;
         else
          return buff.EncodeTable[ch];
     } else if ( EInfo.AnsiMode ){
        OemToCharBuff( (LPCTSTR)&ch,(LPTSTR)&ch,1 );
        return ch;
     } else {
       return ch;
     }
}

static BOOL GetAsyncKeyStateDual(DWORD vk)
{
    if( !isWinNT ){
        if( vk==VK_CONTROL )
            return (LastShiftState&(RIGHT_CTRL_PRESSED|LEFT_CTRL_PRESSED))==0;
        else if( vk==VK_MENU )
            return (LastShiftState&(RIGHT_ALT_PRESSED|LEFT_ALT_PRESSED))==0;
        else if( vk==VK_SHIFT )
            return (LastShiftState&(SHIFT_PRESSED))==0;
    }
    return GetAsyncKeyState(vk)>=0;
}

__forceinline static BOOL isTempShow( void )
  {
       if ( (Options.opTempShow&(CRTS_CONTROL|CRTS_ALT|CRTS_SHIFT)) == 0 ) return FALSE;
       if ( IS_FLAG(Options.opTempShow,CRTS_CONTROL) && GetAsyncKeyStateDual(VK_CONTROL) ) return FALSE;
       if ( IS_FLAG(Options.opTempShow,CRTS_ALT)     && GetAsyncKeyStateDual(VK_MENU)    ) return FALSE;
       if ( IS_FLAG(Options.opTempShow,CRTS_SHIFT)   && GetAsyncKeyStateDual(VK_SHIFT)   ) return FALSE;
       return TRUE;
}

static BOOL GetKeyStateDual(DWORD vk)
{
    if( !isWinNT ){
        if( vk==VK_CAPITAL )
            return LastShiftState&CAPSLOCK_ON;
        else if( vk==VK_NUMLOCK )
            return LastShiftState&NUMLOCK_ON;
        else if( vk==VK_SCROLL )
            return LastShiftState&SCROLLLOCK_ON;
    }
    return GetKeyState(vk);
}

__forceinline static BOOL isLockShow( void )
  {
       if ( (IS_FLAG(Options.opLockShow,CRLS_CAPS)   && GetKeyStateDual( VK_CAPITAL )) ||
            (IS_FLAG(Options.opLockShow,CRLS_NUM)    && GetKeyStateDual( VK_NUMLOCK )) ||
            (IS_FLAG(Options.opLockShow,CRLS_SCROLL) && GetKeyStateDual( VK_SCROLL ))  ) {
         if ( isAutoShoot() ) SET_FLAG( Options.opFlags,CRF_SHOOT );
         return TRUE;
       }
       if ( isAutoShoot() ) CLR_FLAG( Options.opFlags,CRF_SHOOT );
       return FALSE;
}

static BOOL isShow( void )
{
    return isTempShow() || isLockShow();
}

__forceinline static BOOL isNotShow( char *fn )
  {  // fn = StrRChr( fn,SLASH_CHAR );
 return (fn)?F_CMP_NAME( Options.opNotShow,fn+1 ):FALSE;
}

__forceinline static BOOL isAlwaysShow( char *fn )
  {  //fn = StrRChr( fn,SLASH_CHAR );
 return (fn)?F_CMP_NAME( Options.opAlwaysShow,fn+1 ):FALSE;
}

static void DoCursor( int x, int y, int color )
{
     struct EditorColor ec;

     if ( Options.opCenterColor ){
       ec.StringNumber=y;
       ec.ColorItem=0;
       ec.StartPos=x;
       ec.EndPos=x;
       ec.Color=color;
       Info.EditorControl( ECTL_ADDCOLOR,&ec );
     }
}

__forceinline static void EditSetCursor(void)
{
    DoCursor(EInfo.CurPos,EInfo.CurLine,Options.opCenterColor);
}
__forceinline static void DelCursor( int x,int y )
{
    DoCursor(x,y,0);
}

static void DoColorize(int x, int y, BOOL isSet, WORD wFlags )
{
    int n;
    struct EditorColor ec;
    struct EditorConvertPos ecp;
    int tab_x;

     zero_mem(&ec,sizeof(ec));
     ec.StringNumber=y;
     if( isSet ){
         ec.StartPos=EInfo.LeftPos;
         ec.EndPos=EInfo.LeftPos+EInfo.WindowSizeX;
         ec.Color=Options.opColor;
     }else
         ec.StartPos=-1;

//Prepare to correct TABs
    ecp.StringNumber=y;
    ecp.SrcPos=x;
    Info.EditorControl(ECTL_REALTOTAB,&ecp);
    tab_x=ecp.DestPos;
//Horizontal
     if ( IS_FLAG(wFlags,CRF_HORZ) )
       Info.EditorControl( ECTL_ADDCOLOR,&ec );
//Vertical
     if ( IS_FLAG(Options.opFlags,CRF_VERT) )
       for ( n = 0; n < EInfo.WindowSizeY; n++ ) {
         ecp.StringNumber =
         ec.StringNumber = last.TopLine + n;
         ecp.SrcPos = tab_x;
         Info.EditorControl(ECTL_TABTOREAL,&ecp);
         ec.StartPos     =
         ec.EndPos       = ecp.DestPos;
         Info.EditorControl( ECTL_ADDCOLOR,&ec );
       }
//Center
     if ( (wFlags&(CRF_HORZ|CRF_VERT))==0 )
        DoCursor(x,y,isSet?Options.opCenterColor:0);
}

static void Ruler()
{
    char buff[11];
    int i;
    static const char sz4dot[]="....+....|";

    for( i=0; i<EInfo.WindowSizeX; i+=10 ){
        strcpy(buff,sz4dot);
        buff[F_SPRINTF(buff,szDecimalFmt,(i?i:1)+EInfo.LeftPos)]='.';
        Info.Text(i,0,0xF0,buff);
        //Info.Text(i,EInfo.WindowSizeY+1,0xF0,buff);
        /*
        {
            HANDLE hConsole=GetStdHandle(STD_OUTPUT_HANDLE);
            COORD c;
            DWORD dwDummy;

            c.X=(SHORT)i;
            c.Y=0;
            WriteConsoleOutputCharacter(hConsole,buff,10,c,&dwDummy);
            FillConsoleOutputAttribute(hConsole,0xF0,10,c,&dwDummy);
            c.Y=(SHORT)(EInfo.WindowSizeY+1);
            WriteConsoleOutputCharacter(hConsole,buff,10,c,&dwDummy);
            FillConsoleOutputAttribute(hConsole,0xF0,10,c,&dwDummy);
        }
        */
    }
}

__forceinline static void SetColorize()
  {
    DoColorize(EInfo.CurPos,EInfo.CurLine,TRUE,Options.opFlags);
//Store flags for restore
     last.LastFlags = Options.opFlags;
}

__forceinline static void DelColorize( int x,int y )
  {
     if ( last.LastFlags == MAX_WORD ||    //not setted
          isColorer()                 //Colorer process full redraw - not need to delete color sections
        ) return;

    DoColorize(x,y,FALSE,last.LastFlags);
}
//- CONFIG

#pragma pack(push,1)
struct FarDialogItemTpl
{
  int Selected;
  DWORD Flags;
  unsigned char Type;
  unsigned char X1;
  unsigned char Y1;
  unsigned char X2;
  unsigned char LngNum;
};
#pragma pack(pop)

static BOOL DoConfigure( void )
  {
  static const char szTitleFmt      [] =CR_VERSION" / Win%-52s";
  static const char szFixFmt        [] ="###";
  static const char szWinNT         [] ="NT";
  static const char szWin9x         [] ="9x";

  static const struct FarDialogItemTpl itm_tpl[] = {
       { 0,    DIF_SETCOLOR | 0x9E,        DI_TEXT, 0, 0, 0, 255 },

       { 0,    0,                      DI_CHECKBOX, 1, 1, 0, lngEnabled },
       { 0,    0,                      DI_CHECKBOX,18, 1, 0, lngCLRCursor },
       { 0,    0,                      DI_CHECKBOX,40, 1, 0, lngShootMode },

       { (int)szFixFmt, DIF_MASKEDIT,   DI_FIXEDIT,18, 2,21, 255 },
       { 0,    0,                          DI_TEXT, 3, 2, 0, lngCRColor },
       { (int)szFixFmt, DIF_MASKEDIT,   DI_FIXEDIT,18, 3,21, 255 },
       { 0,    0,                          DI_TEXT, 3, 3, 0, lngCURColor },

       { 0,    DIF_LEFTTEXT,               DI_TEXT, 1, 5, 0, lngActivs },
       { 0,    DIF_GROUP,              DI_CHECKBOX, 2, 6, 0, lngCtrl },
       { 0,    0,                      DI_CHECKBOX, 2, 7, 0, lngAlt },
       { 0,    0,                      DI_CHECKBOX, 2, 8, 0, lngShift },

       { 0,    DIF_LEFTTEXT,               DI_TEXT,15, 5, 0, lngLock },
       { 0,    DIF_GROUP,              DI_CHECKBOX,16, 6, 0, lngCaps },
       { 0,    0,                      DI_CHECKBOX,16, 7, 0, lngNum },
       { 0,    0,                      DI_CHECKBOX,16, 8, 0, lngScroll },
       { 0,    0,                      DI_CHECKBOX,15, 9, 0, lngAutoShoot },

       { 0,    DIF_LEFTTEXT,          DI_SINGLEBOX,32, 2,68, lngOpt },
       { 0,    DIF_GROUP,              DI_CHECKBOX,33, 3, 0, lngColorerCor },
       { 0,    0,                      DI_CHECKBOX,33, 4, 0, lngDrawV },
       { 0,    0,                      DI_CHECKBOX,33, 5, 0, lngDrawH },
       { 0,    0,                      DI_CHECKBOX,33, 6, 0, lngShCfg },
       { 0,    0,                      DI_CHECKBOX,33, 7, 0, lngNewFar },
       { 0,    0,                      DI_CHECKBOX,33, 8, 0, lngIgnDel },
       { 0,    0,                      DI_CHECKBOX,33, 9, 0, lngShowRuler },

       { 0,    0,                          DI_TEXT, 1,10, 0, lngAlways },
       { 0,    0,                          DI_EDIT, 3,11,68, 255 },

       { 0,    0,                          DI_TEXT, 1,12, 0, lngNever },
       { 0,    0,                          DI_EDIT, 3,13,68, 255 }
     };
     struct  FarDialogItem itm[sizeof(itm_tpl)/sizeof(itm_tpl[0])];
     size_t i;
#define CD_OS         0
#define CD_ENABLED    1
#define CD_CURSOR     2
#define CD_SHOOT      3

#define CD_COLOR      4
#define CD_CCOLOR     6

#define CD_CONTROL    9
#define CD_ALT        10
#define CD_SHIFT      11

#define CD_CAPS       13
#define CD_NUM        14
#define CD_SCROLL     15
#define CD_AUTOSHOOT  16

#define CD_OPT        17
#define CD_COLORER    18
#define CD_VERT       19
#define CD_HORZ       20
#define CD_CONFIG     21
#define CD_FAR173     22
#define CD_IGNOREDEL  23
#define CD_SHOWRULER  24

#define CD_ALLSH      26
#define CD_NOTSH      28

     zero_mem(&itm,sizeof(itm));
     for( i=0; i<sizeof(itm_tpl)/sizeof(itm_tpl[0]); i++ ){
        itm[i].Type=itm_tpl[i].Type;
        itm[i].X1=itm_tpl[i].X1;
        itm[i].Y1=itm_tpl[i].Y1;
        itm[i].X2=itm_tpl[i].X2;
        itm[i].Selected=itm_tpl[i].Selected;
        itm[i].Flags=itm_tpl[i].Flags;
        if( itm_tpl[i].LngNum!=255 ) strcpy(itm[i].Data,Info.GetMsg(Info.ModuleNumber,itm_tpl[i].LngNum));
     }
     itm[CD_OPT].Y2=10;
//OS caption
     F_SPRINTF(itm[CD_OS].Data,szTitleFmt,(isWinNT)?szWinNT:szWin9x);
//Main tasks
//Enabled
     itm[CD_ENABLED].Selected = Options.opEnabled;
//Colorize cursor
     itm[CD_CURSOR].Selected  = IS_FLAG(Options.opFlags,CRF_CURSOR);
//Char shoot
     itm[CD_SHOOT].Selected   = IS_FLAG(Options.opFlags,CRF_SHOOT);
//Colors
     F_SPRINTF( itm[CD_COLOR].Data,  szDecimalFmt,Options.opColor );
     F_SPRINTF( itm[CD_CCOLOR].Data, szDecimalFmt,Options.opCenterColor );
//Activators
     itm[CD_CONTROL].Selected  = IS_FLAG(Options.opTempShow,CRTS_CONTROL);
     itm[CD_ALT].Selected      = IS_FLAG(Options.opTempShow,CRTS_ALT);
     itm[CD_SHIFT].Selected    = IS_FLAG(Options.opTempShow,CRTS_SHIFT);
//Lockers
     itm[CD_CAPS].Selected     = IS_FLAG(Options.opLockShow,CRLS_CAPS);
     itm[CD_NUM].Selected      = IS_FLAG(Options.opLockShow,CRLS_NUM);
     itm[CD_SCROLL].Selected   = IS_FLAG(Options.opLockShow,CRLS_SCROLL);
//Flags
     itm[CD_AUTOSHOOT].Selected  = IS_FLAG(Options.opFlags,CRF_AUTOSHOOT);
     itm[CD_COLORER].Selected    = IS_FLAG(Options.opFlags,CRF_COLORER);
     itm[CD_VERT].Selected       = IS_FLAG(Options.opFlags,CRF_VERT);
     itm[CD_HORZ].Selected       = IS_FLAG(Options.opFlags,CRF_HORZ);
     itm[CD_CONFIG].Selected     = IS_FLAG(Options.opFlags,CRF_PLUGINMENU);
     itm[CD_FAR173].Selected     = IS_FLAG(Options.opFlags,CRF_FAR173);
     itm[CD_SHOOT].Selected      = IS_FLAG(Options.opFlags,CRF_SHOOT);
     itm[CD_IGNOREDEL].Selected  = IS_FLAG(Options.opFlags,CRF_IGNOREDEL);
     itm[CD_SHOWRULER].Selected  = IS_FLAG(Options.opFlags,CRF_SHOWRULER);
//Patterns
     StrCpy( itm[CD_ALLSH].Data, Options.opAlwaysShow,  sizeof(itm[0].Data) );
     StrCpy( itm[CD_NOTSH].Data, Options.opNotShow,     sizeof(itm[0].Data) );

// !!Dialog
     if ( Info.Dialog( Info.ModuleNumber,-1,-1,70,15,NULL,itm,sizeof(itm)/sizeof(itm[0]) ) == -1 ) return FALSE;

     Options.opFlags    = 0;
     Options.opTempShow = 0;
     Options.opLockShow = 0;
//Main tasks
//Enabled
     Options.opEnabled  = itm[CD_ENABLED].Selected;
  //Colorize cursor
      if ( itm[CD_CURSOR].Selected )   SET_FLAG(Options.opFlags,CRF_CURSOR);
  //Char shoot
      if ( itm[CD_SHOOT].Selected )    SET_FLAG(Options.opFlags,CRF_SHOOT);
//Colors
     Options.opColor = F_ATOI( itm[CD_COLOR].Data );
     if (!Options.opColor) Options.opColor = 31;
     Options.opCenterColor = F_ATOI( itm[CD_CCOLOR].Data );
//Activators
       if ( itm[CD_CONTROL].Selected ) SET_FLAG( Options.opTempShow,CRTS_CONTROL );
       if ( itm[CD_ALT].Selected )     SET_FLAG( Options.opTempShow,CRTS_ALT );
       if ( itm[CD_SHIFT].Selected )   SET_FLAG( Options.opTempShow,CRTS_SHIFT );
//Lockers
       if ( itm[CD_CAPS].Selected   )  SET_FLAG(Options.opLockShow,CRLS_CAPS);
       if ( itm[CD_NUM].Selected    )  SET_FLAG(Options.opLockShow,CRLS_NUM);
       if ( itm[CD_SCROLL].Selected )  SET_FLAG(Options.opLockShow,CRLS_SCROLL);
//Flags
      if ( itm[CD_AUTOSHOOT].Selected )SET_FLAG(Options.opFlags,CRF_AUTOSHOOT);
      if ( itm[CD_COLORER].Selected )  SET_FLAG(Options.opFlags,CRF_COLORER);
      if ( itm[CD_VERT].Selected )     SET_FLAG(Options.opFlags,CRF_VERT);
      if ( itm[CD_HORZ].Selected )     SET_FLAG(Options.opFlags,CRF_HORZ);
      if ( itm[CD_CONFIG].Selected )   SET_FLAG(Options.opFlags,CRF_PLUGINMENU);
      if ( itm[CD_FAR173].Selected )    SET_FLAG(Options.opFlags,CRF_FAR173);
      if ( itm[CD_IGNOREDEL].Selected ) SET_FLAG(Options.opFlags,CRF_IGNOREDEL);
      if ( itm[CD_SHOWRULER].Selected ) SET_FLAG(Options.opFlags,CRF_SHOWRULER);
//Patterns
     StrCpy( Options.opAlwaysShow, itm[CD_ALLSH].Data, sizeof(Options.opAlwaysShow) );
     StrCpy( Options.opNotShow,    itm[CD_NOTSH].Data, sizeof(Options.opNotShow) );

// !!Save config
     SaveREG();
 return TRUE;
}
//- REDRAWS
__forceinline static void DoEventRedraw(void)
  {
    last.TopLine = EInfo.TopScreenLine;
    if (last.isHilight) SetColorize(); else
    if (isCursor()) EditSetCursor();
}

static void DoEventFull( void *Param )
  {  int cx = EInfo.CurPos,
         cy = EInfo.CurLine;
//Need to repaint
    if ( Param == EEREDRAW_CHANGE               ||   //Text chenged
         last.curX != cx                        ||   //Cursor moved
         last.curY != cy                        ||
         EInfo.TopScreenLine != last.TopLine    ||   //Screen moved
         last.isHilight != last.hilight ) { // needRepaint
    //Force full redraw
      if ( Param != EEREDRAW_ALL ) { Info.EditorControl( ECTL_REDRAW,EEREDRAW_ALL ); return; }
    //Hilighting
      if ( isCrest() && (last.isHilight || last.isHilight != last.hilight) ) {
        //Delete old drawing
        if (last.curX != -1) { DelColorize( last.curX,last.curY ); last.curX = -1; }
        //Draw crest
        if (last.isHilight) {
          last.curX    = cx;
          last.curY    = cy;
          last.TopLine = EInfo.TopScreenLine;
          SetColorize();
        }
        if ( !last.isHilight && isCursor() ){
          last.curX    = cx;
          last.curY    = cy;
          EditSetCursor();
        }
      } else
    //Cursor
      if ( isCursor() ) {
        if (last.curX != -1) { DelCursor( last.curX,last.curY ); last.curX = -1; }
        last.curX=cx;
        last.curY=cy;
        EditSetCursor();
      }
    }
}

//- FAR interface
#ifdef __cplusplus
extern "C" {
#endif
int WINAPI ProcessEditorInput( INPUT_RECORD * ir)
  {  static const BYTE IgnoreModifiers[] = { scRETURN, 0 };
     static const BYTE Modifiers[] = { scBACKSPACE, scTAB, 0 };
     const DWORD ANY_SHIFT   = LEFT_ALT_PRESSED | LEFT_CTRL_PRESSED | RIGHT_ALT_PRESSED | RIGHT_CTRL_PRESSED | SHIFT_PRESSED;
     struct EditorGetString gs;
     struct EditorSetString ss;
     char            ch;

    if ( !isWinNT ) {
      if ( ir->EventType == KEY_EVENT && ir->Event.KeyEvent.wVirtualScanCode )
        LastShiftState = ir->Event.KeyEvent.dwControlKeyState;
       else
      if ( ir->EventType == MOUSE_EVENT )
        LastShiftState = ir->Event.MouseEvent.dwControlKeyState;
    }
  //Enabled
    if ( !Options.opEnabled ) return 0;
  //Char shoot
    if ( isShoot() ) {
        if ( ir->EventType != KEY_EVENT ) goto NoShoot;
        if ( !ir->Event.KeyEvent.bKeyDown ) goto NoShoot;
        if ( !ir->Event.KeyEvent.wVirtualScanCode ) goto NoShoot;
        if ( !ir->Event.KeyEvent.uChar.AsciiChar ) goto NoShoot;
      //Ignore line modifiers
        if ( isIgnoreDEL() &&
             (ir->Event.KeyEvent.dwControlKeyState&ANY_SHIFT) == 0 &&
             StrChr((char*)IgnoreModifiers,ir->Event.KeyEvent.wVirtualScanCode) != NULL
             )
          return 1;
      //Replace line modifiers
        if ( isIgnoreDEL() &&
             (ir->Event.KeyEvent.dwControlKeyState&ANY_SHIFT) == 0 &&
             StrChr((char*)Modifiers,ir->Event.KeyEvent.wVirtualScanCode) != NULL
             )
          ir->Event.KeyEvent.uChar.AsciiChar = ' '; //return 1;
      //Editor object
        Info.EditorControl( ECTL_GETINFO, &EInfo );
      //Character
        ch = (char)IsChar( ir->Event.KeyEvent.uChar.AsciiChar );
        if ( !ch ) goto NoShoot;
      //Get current line
        gs.StringNumber = -1;
        if ( !Info.EditorControl(ECTL_GETSTRING,&gs) ) goto NoShoot;
      //Out of line size
        if ( EInfo.CurPos > gs.StringLength ) return 1;
      //Replace current character
        gs.StringText[ EInfo.CurPos ] = ch;
        ss.StringNumber = -1;
        ss.StringText   = gs.StringText;
        ss.StringEOL    = NULL;
        ss.StringLength = gs.StringLength;
        Info.EditorControl(ECTL_SETSTRING,&ss);
        Info.EditorControl( ECTL_REDRAW,EEREDRAW_ALL );
      //Force FAR to ignore key
        return 1;
    }
NoShoot:
  //Look for lockers\activators
    last.isHilight = isShow();
  //Force repaint if changes
    if ( last.isHilight != last.hilight ) {
      Info.EditorControl( ECTL_REDRAW,EEREDRAW_ALL );
      last.hilight = last.isHilight;
      if( last.isHilight && isShowRuler() )Ruler();
    } else
  //Force Key repaint
    if ( !isColorer() && !isNewFAR() && ir->EventType == KEY_EVENT && ir->Event.KeyEvent.wVirtualScanCode )
      Info.EditorControl( ECTL_REDRAW,EEREDRAW_LINE );

  return 0;
}

int WINAPI ProcessEditorEvent( int Event, void *Param )
  {
//Enabled
    if ( !Options.opEnabled ) return 0;
//Other events
    if ( Event != EE_REDRAW ) { last.curX = -1; return 0; }
//In editor
    Info.EditorControl( ECTL_GETINFO, &EInfo );
//Correct hilights
  //Not hilight
    if ( last.isHilight && !isShow() ) last.isHilight = FALSE;
  //Force hilight
  {
    char *m = StrRChr( EInfo.FileName,SLASH_CHAR );
    if ( isAlwaysShow(m) )             { last.isHilight = TRUE; last.hilight = FALSE; }
  //OFF hilight
    if ( isNotShow(m) )                 last.isHilight = FALSE;
  }
//Process event by selected types
    if (isColorer())DoEventRedraw();
    else DoEventFull(Param);

    return 0;
}

HANDLE WINAPI OpenPlugin( int from,int Item)
  {
    BOOL center, crest;

    (void)Item;
//Process emulated config
    if ( from != OPEN_EDITOR ) return INVALID_HANDLE_VALUE;
  //Save current status
    center = Options.opEnabled && isCursor();
    crest  = Options.opEnabled && last.isHilight;
  //Do configure
    if ( !DoConfigure() ) return INVALID_HANDLE_VALUE;
  //Check statuses disabled
    if ( last.curX != -1 && !isColorer() ) {       //Not drawed
      Info.EditorControl( ECTL_GETINFO, &EInfo );
      //Crest disabled|changed
      if ( crest > (Options.opEnabled && last.isHilight) ) {
        if (last.curX != -1) DelColorize( last.curX,last.curY );
        last.curX = -1;
      } else
      //Center disabled|changed
      if ( center > (Options.opEnabled && isCursor()) ) {
        if (last.curX != -1) DelCursor( last.curX,last.curY );
        last.curX = -1;
      }
    }
  //Do repaint
    Info.EditorControl( ECTL_REDRAW,EEREDRAW_ALL );
  return INVALID_HANDLE_VALUE;
}
int WINAPI Configure( int ItemNumber )
  {
//Process normal config
 return ItemNumber == 0 && DoConfigure();
}
void WINAPI SetStartupInfo( struct PluginStartupInfo *pInfo )
  {
    static const char szCrest[]="Crest";
    static const char szKeyFmt[]="%s\\%s";

    Options.opMagic         =CR_MAGIC;
    Options.opEnabled       =TRUE;
    Options.opColor         =0x47;
    Options.opTempShow      =CRTS_CONTROL | CRTS_ALT;
    Options.opLockShow      =CRLS_SCROLL;
    Options.opFlags         =CRF_VERT | CRF_HORZ | CRF_CURSOR | CRF_PLUGINMENU | CRF_SHOWRULER;
    Options.opCenterColor   =240;
    last.curX      = -1;
    last.curY      = -1;
    last.hilight   = -1;
    last.isHilight = -1;
    last.LastFlags = MAX_WORD;
    isWinNT = GetVersion() < 0x80000000UL;

    F_INIT_STRUCTDATA( pInfo );
    F_SPRINTF( KeyName,szKeyFmt,Info.RootKey,szCrest );
    LoadREG();
}

void WINAPI GetPluginInfo( struct PluginInfo *pInfo )
  {
    static char* mnu;

    mnu=Info.GetMsg(Info.ModuleNumber,lngEditorCrestSetup);

    zero_mem(pInfo,sizeof(*pInfo));

    pInfo->StructSize                = sizeof(*pInfo);
    pInfo->Flags                     = PF_EDITOR | PF_DISABLEPANELS;

    if ( isPluginMenu() ) {
      pInfo->PluginMenuStrings         = &mnu;
      pInfo->PluginMenuStringsNumber   = 1;
    }

    pInfo->PluginConfigStrings       = &mnu;
    pInfo->PluginConfigStringsNumber = 1;

}
#ifdef __cplusplus
}
#endif

//! DLL Main
BOOL WINAPI DllMain(HINSTANCE hinst, unsigned long reason, void* ptr)
{
    static const char StdChars[]  = "㪥뢠஫ᬨ񉖓";
    static const char szShootChars[]="ShootChars";
    static const char szSpace[]="\t\r\n\b";
    char   str[ MAX_PATH ];
    HANDLE f;
    DWORD  sz,dw;

    (void)ptr;
    if( reason==DLL_PROCESS_ATTACH ){
//Read specific characters file if exist; set to default one otherwise
       str[GetModuleFileName( hinst,str,sizeof(str)-1 )] = '\0';
       StrRChr( str,'\\' )[1] = '\0';
       strcat( str,szShootChars );
       f = CreateFile( str,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL );
       if ( f == INVALID_HANDLE_VALUE ) goto ErrRead;
       sz = GetFileSize(f,NULL);
       if ( !sz ) goto ErrRead;
       if( sz>255 ) sz=255;
       if ( ReadFile( f,Chars,sz,&dw,NULL ) == 0 || sz != dw ) goto ErrRead;
       Chars[ sz ] = '\0';
       goto Readed;
     ErrRead:
       memcpy( Chars,StdChars,sizeof(StdChars) );
     Readed:
       if ( f != INVALID_HANDLE_VALUE ) CloseHandle(f);
       for ( dw = 0; Chars[dw]; dw++ )
         if ( StrChr(szSpace,Chars[dw]) != NULL ) Chars[dw] = ' ';
    }
    return TRUE;
}
